from tkinter import *
from model3D import *

#■メインプログラム
root= Tk()
root.title("Ray Tracing Ball and Floor")
canvas=Canvas(root,width=500,height=400)
canvas.pack()
z_buff=[[-1e30 for j in range(400)] for i in range(500)]
init2D(500,400)
origin(250,200)
Ba = Ball(Point(0,0,50),100)
Wa=Wall((Point( 200, 200,-50),Point(-200, 200,-50),
         Point(-200,-200,-50),Point( 200,-200,-50)))
Cb=Color(255,0,0)
Cw=Color(255,255,255)
V0= Point(500,500,500)                #視点
L0= Point(-100,100,1000)              #照明光
setview(V0)
k=0
NP=size_xy.x//20
for x in range(size_xy.x):
    if x % NP==0:
        k+=1
        root.title("Ray Tracing Ball and Floor" + "■"*k)
        root.update()
        
    for y in range(size_xy.y):
        V  = unit(world(Point(x, y,-dv))-V0)    #視線ベクトル
        VR = Ray(V0,V)                          #視線
        s=1
        R=Ba.hit(VR)
        Cs=Color(0,0,0)
        if(R[0]<1E8):
            P=R[1]; N=R[2]
            L=unit(P-L0)
            Cs=shading(V,L,N,Cb)
        else:
            R=Wa.hit(VR)
            if(R[0]<1E8):
                P=R[1]; N=R[2]
                L=unit(P-L0)
                LR = Ray(L0, L)     # 照明光方向にボールがあるときは
                R = Ba.hit(LR)      # 環境光のみとする(s=0)
                if R[0]<1E8 : s=0
                Cs=shading(V, L, N, Cw, s)
        drawPointXY(canvas, x,y,Cs.toString())
root.title("Ray Tracing 完了" )
root.update()
            
